# This file was auto-generated by Fern from our API Definition.

import typing

import httpx

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .resources.api_keys.client import ApiKeysClient, AsyncApiKeysClient
from .resources.connections.client import AsyncConnectionsClient, ConnectionsClient
from .resources.destinations.client import AsyncDestinationsClient, DestinationsClient
from .resources.embedding_models.client import AsyncEmbeddingModelsClient, EmbeddingModelsClient
from .resources.health.client import AsyncHealthClient, HealthClient
from .resources.sources.client import AsyncSourcesClient, SourcesClient
from .resources.sync.client import AsyncSyncClient, SyncClient
from .resources.users.client import AsyncUsersClient, UsersClient
from .resources.white_labels.client import AsyncWhiteLabelsClient, WhiteLabelsClient


class AirweaveApi:
    def __init__(
        self,
        *,
        base_url: str,
        api_key: typing.Optional[str] = None,
        timeout: typing.Optional[float] = 60,
        httpx_client: typing.Optional[httpx.Client] = None
    ):
        self._client_wrapper = SyncClientWrapper(
            base_url=base_url,
            api_key=api_key,
            httpx_client=httpx.Client(timeout=timeout) if httpx_client is None else httpx_client,
        )
        self.health = HealthClient(client_wrapper=self._client_wrapper)
        self.api_keys = ApiKeysClient(client_wrapper=self._client_wrapper)
        self.users = UsersClient(client_wrapper=self._client_wrapper)
        self.sources = SourcesClient(client_wrapper=self._client_wrapper)
        self.destinations = DestinationsClient(client_wrapper=self._client_wrapper)
        self.embedding_models = EmbeddingModelsClient(client_wrapper=self._client_wrapper)
        self.connections = ConnectionsClient(client_wrapper=self._client_wrapper)
        self.sync = SyncClient(client_wrapper=self._client_wrapper)
        self.white_labels = WhiteLabelsClient(client_wrapper=self._client_wrapper)


class AsyncAirweaveApi:
    def __init__(
        self,
        *,
        base_url: str,
        api_key: typing.Optional[str] = None,
        timeout: typing.Optional[float] = 60,
        httpx_client: typing.Optional[httpx.AsyncClient] = None
    ):
        self._client_wrapper = AsyncClientWrapper(
            base_url=base_url,
            api_key=api_key,
            httpx_client=httpx.AsyncClient(timeout=timeout) if httpx_client is None else httpx_client,
        )
        self.health = AsyncHealthClient(client_wrapper=self._client_wrapper)
        self.api_keys = AsyncApiKeysClient(client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=self._client_wrapper)
        self.sources = AsyncSourcesClient(client_wrapper=self._client_wrapper)
        self.destinations = AsyncDestinationsClient(client_wrapper=self._client_wrapper)
        self.embedding_models = AsyncEmbeddingModelsClient(client_wrapper=self._client_wrapper)
        self.connections = AsyncConnectionsClient(client_wrapper=self._client_wrapper)
        self.sync = AsyncSyncClient(client_wrapper=self._client_wrapper)
        self.white_labels = AsyncWhiteLabelsClient(client_wrapper=self._client_wrapper)
