# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .sync_status import SyncStatus

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Sync(pydantic.BaseModel):
    """
    Schema for Sync.
    """

    name: str
    description: typing.Optional[str]
    source_connection_id: str
    destination_connection_id: typing.Optional[str]
    embedding_model_connection_id: typing.Optional[str]
    cron_schedule: typing.Optional[str]
    white_label_id: typing.Optional[str]
    white_label_user_identifier: typing.Optional[str]
    sync_metadata: typing.Optional[typing.Dict[str, typing.Any]]
    id: str
    organization_id: str
    created_at: dt.datetime
    modified_at: dt.datetime
    created_by_email: str
    modified_by_email: str
    status: SyncStatus

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
